package cz.muni.fi.pb138.jaro2012.uloha1;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * ***********************************************************************
 * Take this skeleton code and implement the missing body of
 * the below indicated three methods. Everything else should be left
 * untouched.<br/>
 *
 * After completion, the
 * <code>main</code> method should work correctly.<br/>
 *
 * You may use either NetBeans or Ant build.xml to compile and run it.
 */
public class Main {

    /**
     * W3C object model representation of a XML document. Note: We use the
     * interface(!) not its implementation
     */
    private Document doc;

    /**
     * Task 1, part A: Complete the methods detachCar and moveCarTo.
     *
     * Sells the car identified by carId to the person identified by personId.
     * (i.e. moves the respective car element into the cars element of the
     * recipient person, new owner. Note that if the recipient does not have any
     * cars yet, the containing cars element must first be created before the
     * cars is moved into it. if either the car or the recipient is not present,
     * the method does not change nor report anything.
     *
     * @param carId id of the car to be sold
     * @param personId person receiving the car
     * @throws IllegalArgumentException, NullPointerException 
     * if any parameter is null or empty
     */
    public void sellCarTo(String carId, String personId) {
        Element car = detachCar(carId);
        if (car != null) {
            moveCarTo(car, personId);
        }
    }

    public Element detachCar(String carId) {
        // complete the code here
        return null;
    }

    private void moveCarTo(Element car, String personId) {
       // complete the code here
    }

    private static boolean nullOrEmpty(String s) {
        return s == null || s.isEmpty();
    }

    /**
     * ***********************************************************************
     * Task 1, part B: Complete this method.
     *
     * This method calculates the average year of all the cars. Hint: Iterate
     * over all cars years (in the year elements) in the file and calculate the
     * sum of them. Then, divide it by the number of cars and return it. (The
     * XML document must not be modified anyhow by this method.)
     *
     * @return the average year of all cars in the document (as integer / type
     * int)
     */
    public int getAverageCarYear() {
       // complete the code here
        return 0;
    }

    /**
     * **********************************************************************
     */
    /**
     * Vytvori novou instanci teto tridy a nacte obsah xml dokumentu se zadanym
     * URL.
     */
    public static Main newInstance(URI uri) throws SAXException,
            ParserConfigurationException, IOException {
        return new Main(uri);
    }

    /**
     * Create a new instance of this class and read the content of the given XML
     * file.
     */
    public static Main newInstance(File file)
            throws SAXException, ParserConfigurationException, IOException {
        return newInstance(file.toURI());
    }

    /**
     * Constructor creating a new instance of Uloha1 class reading from the file
     * at the given URI
     */
    private Main(URI uri) throws SAXException, ParserConfigurationException,
            IOException {
        // Vytvorime instanci tovarni tridy
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse(uri.toString());
    }

    public void serializetoXML(URI output)
            throws IOException, TransformerConfigurationException, TransformerException {
        // Vytvorime instanci tovarni tridy
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(output.toString());
        // Provedeme transformaci
        transformer.transform(source, result);
    }

    public void serializetoXML(File output) throws IOException,
            TransformerException {
        serializetoXML(output.toURI());
    }

    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException {

        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro "
                    + "zpracovani!");
            return;
        } else if (args.length < 2) {
            System.err.println("Chybi argument se jmenem vystupniho souboru!");
            return;
        }

        File input = new File(args[0]);
        File output = new File(args[1]);

        Main uloha1 = newInstance(input);

        System.out.println("Average car year is " + uloha1.getAverageCarYear());

        // sell the newer Octavia to Novak
        uloha1.sellCarTo("6B6 82-51", "1");

        // sell the older Octavia to Polak
        uloha1.sellCarTo("ZNH 28-51", "2");

        uloha1.serializetoXML(output);
    }

    /**
     * Help method for testing purposes.
     */
    Document getDocument() {
        return doc;
    }
}
